﻿/* http://keith-wood.name/calculator.html
   Calculator field entry extension for jQuery v1.0.1.
   Written by Keith Wood (kbwood@virginbroadband.com.au) October 2008.
   Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and 
   MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses. 
   Please attribute the author if you use it. */
(function($){var p='calculator';function Calculator(){this._curInst=null;this._disabledInputs=[];this._calculatorShowing=false;this._mainDivId='calculator-div';this._appendClass='calculator-append';this._triggerClass='calculator-trigger';this._coverClass='calculator-cover';this._uuid=new Date().getTime();this.digit='d';this.binary='b';this.unary='u';this.control='c';this.space='s';this._keyDefs={'_0':['0',this.digit,'','','0','0'],'_1':['1',this.digit,'','','1','1'],'_2':['2',this.digit,'','','2','2'],'_3':['3',this.digit,'','','3','3'],'_4':['4',this.digit,'','','4','4'],'_5':['5',this.digit,'','','5','5'],'_6':['6',this.digit,'','','6','6'],'_7':['7',this.digit,'','','7','7'],'_8':['8',this.digit,'','','8','8'],'_9':['9',this.digit,'','','9','9'],'_A':['A',this.digit,'','hex-digit','A','a'],'_B':['B',this.digit,'','hex-digit','B','b'],'_C':['C',this.digit,'','hex-digit','C','c'],'_D':['D',this.digit,'','hex-digit','D','d'],'_E':['E',this.digit,'','hex-digit','E','e'],'_F':['F',this.digit,'','hex-digit','F','f'],'_.':['.',this.digit,'','decimal','DECIMAL','.'],'_+':['+',this.binary,'._add','arith add','ADD','+'],'_-':['-',this.binary,'._subtract','arith subtract','SUBTRACT','-'],'_*':['*',this.binary,'._multiply','arith multiply','MULTIPLY','*'],'_/':['/',this.binary,'._divide','arith divide','DIVIDE','/'],'_%':['%',this.unary,'._percent','arith percent','PERCENT','%'],'_=':['=',this.unary,'._equals','arith equals','EQUALS','='],'PI':['pi',this.unary,'._pi','pi','PI','p'],'+-':['±',this.unary,'._plusMinus','arith plus-minus','PLUS_MINUS','#'],'1X':['1/x',this.unary,'._inverse','inverse','INV','i'],'LG':['log',this.unary,'._log','log','LOG','l'],'LN':['ln',this.unary,'._ln','ln','LN','n'],'EX':['eⁿ',this.unary,'._exp','exp','EXP','E'],'SQ':['x²',this.unary,'._sqr','sqr','SQR','@'],'SR':['√',this.unary,'._sqrt','sqrt','SQRT','!'],'XY':['x^y',this.binary,'._power','power','POWER','^'],'RN':['rnd',this.unary,'._random','random','RANDOM','?'],'SN':['sin',this.unary,'._sin','trig sin','SIN','s'],'CS':['cos',this.unary,'._cos','trig cos','COS','o'],'TN':['tan',this.unary,'._tan','trig tan','TAN','t'],'AS':['asin',this.unary,'._asin','trig asin','ASIN','S'],'AC':['acos',this.unary,'._acos','trig acos','ACOS','O'],'AT':['atan',this.unary,'._atan','trig atan','ATAN','T'],'MC':['#memClear',this.unary,'._memClear','memory mem-clear','MEM_CLEAR','x'],'MR':['#memRecall',this.unary,'._memRecall','memory mem-recall','MEM_RECALL','r'],'MS':['#memStore',this.unary,'._memStore','memory mem-store','MEM_STORE','m'],'M+':['#memAdd',this.unary,'._memAdd','memory mem-add','MEM_ADD','>'],'M-':['#memSubtract',this.unary,'._memSubtract','memory mem-subtract','MEM_SUBTRACT','<'],'BB':['#base2',this.control,'._base2','base base2','BASE_2','B'],'BO':['#base8',this.control,'._base8','base base8','BASE_8','C'],'BD':['#base10',this.control,'._base10','base base10','BASE_10','D'],'BH':['#base16',this.control,'._base16','base base16','BASE_16','H'],'DG':['#degrees',this.control,'._degrees','angle degrees','DEGREES','G'],'RD':['#radians',this.control,'._radians','angle radians','RADIANS','R'],'BS':['#backspace',this.control,'._undo','undo','UNDO',8],'CE':['#clearError',this.control,'._clearError','clear-error','CLEAR_ERROR',36],'CA':['#clear',this.control,'._clear','clear','CLEAR',35],'@X':['#close',this.control,'._close','close','CLOSE',27],'@U':['#use',this.control,'._use','use','USE',13],'@E':['#erase',this.control,'._erase','erase','ERASE',46],'  ':['',this.space,'','space','SPACE'],'_ ':['',this.space,'','half-space','HALF_SPACE'],'??':['??',this.unary,'._noOp']};this._keyCodes={};this._keyChars={};for(var a in this._keyDefs){if(this._keyDefs[a][4]){this[this._keyDefs[a][4]]=a}if(this._keyDefs[a][5]){if(typeof this._keyDefs[a][5]=='number'){this._keyCodes[this._keyDefs[a][5]]=a}else{this._keyChars[this._keyDefs[a][5]]=a}}}this.standardLayout=['  BSCECA','_1_2_3_+@X','_4_5_6_-@U','_7_8_9_*@E','_0_._=_/'];this.scientificLayout=['@X@U@E  BSCECA','DGRD    _ MC_ _7_8_9_+','SNASSRLG_ MR_ _4_5_6_-','CSACSQLN_ MS_ _1_2_3_*','TNATXYEX_ M+_ _0_.+-_/','PIRN1X  _ M-_   _%_='];this.regional=[];this.regional['']={buttonText:'...',buttonStatus:'Open the calculator',closeText:'Close',closeStatus:'Close the calculator',useText:'Use',useStatus:'Use the current value',eraseText:'Erase',eraseStatus:'Erase the value from the field',backspaceText:'BS',backspaceStatus:'Erase the last digit',clearErrorText:'CE',clearErrorStatus:'Erase the last number',clearText:'CA',clearStatus:'Reset the calculator',memClearText:'MC',memClearStatus:'Clear the memory',memRecallText:'MR',memRecallStatus:'Recall the value from memory',memStoreText:'MS',memStoreStatus:'Store the value in memory',memAddText:'M+',memAddStatus:'Add to memory',memSubtractText:'M-',memSubtractStatus:'Subtract from memory',base2Text:'Bin',base2Status:'Switch to binary',base8Text:'Oct',base8Status:'Switch to octal',base10Text:'Dec',base10Status:'Switch to decimal',base16Text:'Hex',base16Status:'Switch to hexadecimal',degreesText:'Deg',degreesStatus:'Switch to degrees',radiansText:'Rad',radiansStatus:'Switch to radians',isRTL:false};this._defaults={showOn:'focus',buttonImage:'',buttonImageOnly:false,showAnim:'show',showOptions:{},duration:'normal',appendText:'',calculatorClass:'',prompt:'',layout:this.standardLayout,base:10,precision:10,useDegrees:false,onButton:null,onClose:null};$.extend(this._defaults,this.regional['']);this.mainDiv=$('<div id="'+this._mainDivId+'" style="display: none;"></div>')}$.extend(Calculator.prototype,{markerClassName:'hasCalculator',setDefaults:function(a){extendRemove(this._defaults,a||{});return this},addKeyDef:function(a,b,c,d,e,f,g){this._keyDefs[a]=[b,(typeof c=='boolean'?(c?this.binary:this.unary):c),d,e,f,g];if(f){this[f]=a}if(g){if(typeof g=='number'){this._keyCodes[g]=a}else{this._keyChars[g]=a}}return this},_attachCalculator:function(a,b){if(!a.id){a.id='ca'+ ++this._uuid}var c=a.id.replace(/([:\[\]\.])/g,'\\\\$1');var d={_id:c,_input:$(a),_mainDiv:$.calculator.mainDiv};d.settings=$.extend({},b||{});this._connectCalculator(a,d)},_connectCalculator:function(d,e){var f=$(d);if(f.hasClass(this.markerClassName)){return}var g=this._get(e,'appendText');var h=this._get(e,'isRTL');if(g){f[h?'before':'after']('<span class="'+this._appendClass+'">'+g+'</span>')}var i=this._get(e,'showOn');if(i=='focus'||i=='both'){f.focus(this._showCalculator)}if(i=='button'||i=='both'){var j=this._get(e,'buttonText');var k=this._get(e,'buttonStatus');var l=this._get(e,'buttonImage');var m=$(this._get(e,'buttonImageOnly')?$('<img/>').attr({src:l,alt:k,title:k}):$('<button type="button" title="'+k+'"></button>').html(l==''?j:$('<img/>').attr({src:l})));f[h?'before':'after'](m);m.addClass(this._triggerClass).click(function(){if($.calculator._calculatorShowing&&$.calculator._lastInput==d){$.calculator._hideCalculator()}else{$.calculator._showCalculator(d)}return false})}f.addClass(this.markerClassName).keydown(this._doKeyDown).keypress(this._doKeyPress).bind("setData.calculator",function(a,b,c){e.settings[b]=c}).bind("getData.calculator",function(a,b){return this._get(e,b)});$.data(d,p,e)},_destroyCalculator:function(a){var b=$(a);if(!b.hasClass(this.markerClassName)){return}var c=$.data(a,p);b.siblings('.'+this._appendClass).remove().end().siblings('.'+this._triggerClass).remove().end().removeClass(this.markerClassName).unbind('focus',this._showCalculator).unbind('keydown',this._doKeyDown).unbind('keypress',this._doKeyPress);$.removeData(a,p)},_enableCalculator:function(b){var c=$(b);if(!c.hasClass(this.markerClassName)){return}b.disabled=false;c.siblings('button.'+this._triggerClass).each(function(){this.disabled=false}).end().siblings('img.'+this._triggerClass).css({opacity:'1.0',cursor:''});this._disabledInputs=$.map(this._disabledInputs,function(a){return(a==b?null:a)})},_disableCalculator:function(b){var c=$(b);if(!c.hasClass(this.markerClassName)){return}b.disabled=true;c.siblings('button.'+this._triggerClass).each(function(){this.disabled=true}).end().siblings('img.'+this._triggerClass).css({opacity:'0.5',cursor:'default'});this._disabledInputs=$.map(this._disabledInputs,function(a){return(a==b?null:a)});this._disabledInputs[this._disabledInputs.length]=b},_isDisabledCalculator:function(a){return(a&&$.inArray(a,this._disabledInputs)>-1)},_changeCalculator:function(a,b,c){var d=b||{};if(typeof b=='string'){d={};d[b]=c}if(inst=$.data(a,p)){if(this._curInst==inst){this._hideCalculator(null)}extendRemove(inst.settings,d);this._updateCalculator(inst)}},_showCalculator:function(a){a=a.target||a;if($.calculator._isDisabledCalculator(a)||$.calculator._lastInput==a){return}var b=$.data(a,p);$.calculator._hideCalculator(null,'');$.calculator._lastInput=a;$.calculator._pos=$.calculator._findPos(a);$.calculator._pos[1]+=a.offsetHeight;var c=false;$(a).parents().each(function(){c|=$(this).css('position')=='fixed';return!c});if(c&&$.browser.opera){$.calculator._pos[0]-=document.documentElement.scrollLeft;$.calculator._pos[1]-=document.documentElement.scrollTop}var d={left:$.calculator._pos[0],top:$.calculator._pos[1]};$.calculator._pos=null;b._mainDiv.css({position:'absolute',display:'block',top:'-1000px',width:($.browser.opera?'1000px':'auto')});$.calculator._reset(b,b._input.val(),true);$.calculator._updateCalculator(b);d=$.calculator._checkOffset(b,d,c);b._mainDiv.css({position:(c?'fixed':'absolute'),display:'none',left:d.left+'px',top:d.top+'px'});var e=$.calculator._get(b,'showAnim')||'show';var f=$.calculator._get(b,'duration');var g=function(){$.calculator._calculatorShowing=true;if($.browser.msie&&parseInt($.browser.version)<7){$('iframe.'+$.calculator._coverClass).css({width:b._mainDiv.width()+4,height:b._mainDiv.height()+4})}};if($.effects&&$.effects[e]){b._mainDiv.show(e,$.calculator._get(b,'showOptions'),f,g)}else{b._mainDiv[e](f,g)}if(f==''){g()}if(b._input[0].type!='hidden'){b._input[0].focus()}$.calculator._curInst=b},_reset:function(a,b,c){var d=this._get(a,'base');a.curValue=(d==10?parseFloat(b):parseInt(b,d))||0;a.dispValue=a.curValue.toString(d).toUpperCase();a.prevValue=0;a.memory=(c?0:a.memory);a._pendingOp=this._noOp;a._savedOp=this._noOp;a._savedValue=0;a._newValue=true},_updateCalculator:function(a){var b={width:a._mainDiv.width()+4,height:a._mainDiv.height()+4};a._mainDiv.html(this._generateHTML(a)).find('iframe.'+$.calculator._coverClass).css({width:b.width,height:b.height});a._mainDiv.removeClass().addClass(this._get(a,'calculatorClass')+(this._get(a,'isRTL')?' calculator-rtl':''));if(this._curInst==a){a._input.focus()}},_checkOffset:function(a,b,c){var d=a._input?this._findPos(a._input[0]):null;var e=window.innerWidth||document.documentElement.clientWidth;var f=window.innerHeight||document.documentElement.clientHeight;var g=document.documentElement.scrollLeft||document.body.scrollLeft;var h=document.documentElement.scrollTop||document.body.scrollTop;if($.browser.opera){var i=0;$('.calculator-row',a._mainDiv).find('button:last').each(function(){i=Math.max(i,this.offsetLeft+this.offsetWidth+parseInt($(this).css('margin-right')))});a._mainDiv.css('width',i)}if(this._get(a,'isRTL')||(b.left+a._mainDiv.width()-g)>e){b.left=Math.max((c?0:g),d[0]+(a._input?a._input.width():0)-(c?g:0)-a._mainDiv.width()-(c&&$.browser.opera?document.documentElement.scrollLeft:0))}else{b.left-=(c?g:0)}if((b.top+a._mainDiv.height()-h)>f){b.top=Math.max((c?0:h),d[1]-(c?h:0)-(this._inDialog?0:a._mainDiv.height())-(c&&$.browser.opera?document.documentElement.scrollTop:0))}else{b.top-=(c?h:0)}return b},_findPos:function(a){while(a&&(a.type=='hidden'||a.nodeType!=1)){a=a.nextSibling}var b=$(a).offset();return[b.left,b.top]},_hideCalculator:function(a,b){var c=this._curInst;if(!c||(a&&c!=$.data(a,p))){return}if(this._calculatorShowing){b=(b!=null?b:this._get(c,'duration'));var d=this._get(c,'showAnim');if(b!=''&&$.effects&&$.effects[d]){c._mainDiv.hide(d,$.calculator._get(c,'showOptions'),b)}else{c._mainDiv[(b==''?'hide':(d=='slideDown'?'slideUp':(d=='fadeIn'?'fadeOut':'hide')))](b)}var e=this._get(c,'onClose');if(e){e.apply((c._input?c._input[0]:null),[c._input.val(),c])}this._calculatorShowing=false;this._lastInput=null}this._curInst=null},_checkExternalClick:function(a){if(!$.calculator._curInst){return}var b=$(a.target);if(b[0].id!=$.calculator._mainDivId&&b.parents('#'+$.calculator._mainDivId).length==0&&!b.hasClass($.calculator.markerClassName)&&!b.hasClass($.calculator._triggerClass)&&$.calculator._calculatorShowing){$.calculator._hideCalculator(null,'')}},_doKeyDown:function(e){var a=false;if($.calculator._calculatorShowing){var b=$.data(e.target,this.PROP_NAME);var c=$.calculator._keyCodes[e.keyCode];if(c){$('button[keystroke='+c+']',b._mainDiv).not(':disabled').click();a=true}}else if(e.keyCode==36&&e.ctrlKey){$.calculator._showCalculator(this)}if(a){e.preventDefault();e.stopPropagation()}},_doKeyPress:function(e){if($.calculator._calculatorShowing){var a=String.fromCharCode(e.charCode||e.keyCode);var b=$.data(e.target,this.PROP_NAME);var c=$.calculator._keyChars[a];if(c){$('button[keystroke='+c+']',b._mainDiv).not(':disabled').click()}return false}return true},_get:function(a,b){return a.settings[b]!==undefined?a.settings[b]:this._defaults[b]},_generateHTML:function(a){var b=this._get(a,'isRTL');var c=this._get(a,'prompt');var d=this._get(a,'layout');var e=this._get(a,'base');var f=this._get(a,'useDegrees');var g=(!c?'':'<div class="calculator-prompt">'+c+'</div>')+'<div class="calculator-result">'+a.dispValue+'</div>';for(var i=0;i<d.length;i++){g+='<div class="calculator-row">';for(var j=0;j<d[i].length;j+=2){var h=d[i].substr(j,2);var l=this._keyDefs[h]||this._keyDefs['??'];var m=(l[0].charAt(0)=='#'?this._get(a,l[0].substr(1)+'Text'):l[0]);var n=(l[0].charAt(0)=='#'?this._get(a,l[0].substr(1)+'Status'):'');var o=(l[3]?l[3].split(' '):[]);for(var k=0;k<o.length;k++){o[k]='calculator-'+o[k]}o=o.join(' ');g+=(l[1]==this.space?'<span class="calculator-'+l[3]+'"></span>':'<button type="button" keystroke="'+h+'" '+'onmousedown="jQuery(this).addClass(\'calculator-key-down\')" '+'onmouseup="jQuery(this).removeClass(\'calculator-key-down\')" '+'onmouseout="jQuery(this).removeClass(\'calculator-key-down\')" onclick="'+(l[1]==this.control?(l[2].charAt(0)=='.'?'$.calculator':'')+l[2]+'(\''+a._id+'\', \''+m+'\')" class="calculator-ctrl'+(l[0].replace(/^#base/,'')==e?' calculator-base-active':'')+(l[0]=='#degrees'&&f?' calculator-angle-active':'')+(l[0]=='#radians'&&!f?' calculator-angle-active':''):(l[1]==this.digit?'$.calculator._digit(\''+a._id+'\', \''+l[0]+'\')"'+(parseInt(l[0],16)>=e||(e!=10&&l[0]=='.')?' disabled="disabled"':'')+' class="calculator-digit':(l[1]==this.binary?'$.calculator._binaryOp(\''+a._id+'\', '+(l[2].charAt(0)=='.'?'$.calculator':'')+l[2]+', \''+m+'\')" class="calculator-oper':'$.calculator._unaryOp(\''+a._id+'\', '+(l[2].charAt(0)=='.'?'$.calculator':'')+l[2]+', \''+m+'\')" class="calculator-oper'+(l[0].match(/^#mem(Clear|Recall)$/)&&!a.memory?' calculator-mem-empty':''))))+(o?' '+o:'')+'" '+(n?'title="'+n+'"':'')+'>'+m+'</button>')}g+='</div>'}g+='<div style="clear: both;"></div>'+($.browser.msie&&parseInt($.browser.version)<7?'<iframe src="javascript:false;" class="'+$.calculator._coverClass+'"></iframe>':'');return g},_getInst:function(a){return(typeof a=='object'?a:$.data($('#'+a)[0],p))},_sendButton:function(a,b){var c=this._get(a,'onButton');if(c){c.apply((a._input?a._input[0]:null),[b,a.dispValue,a])}},_noOp:function(a){},_digit:function(a,b){a=$.calculator._getInst(a);if(b=='.'&&a.dispValue.indexOf(b)>-1){return}a.dispValue=((a._newValue?'':a.dispValue)+b).replace(/^0(\d)/,'$1').replace(/^\./,'0.');var c=$.calculator._get(a,'base');a.curValue=(c==10?parseFloat(a.dispValue):parseInt(a.dispValue,c));a._newValue=false;$.calculator._sendButton(a,b);$.calculator._updateCalculator(a)},_tidy:function(a,b){var c=new Number(a).toFixed(b).valueOf();var d=c.replace(/^.+(e.+)$/,'$1').replace(/^[^e].*$/,'');if(d){c=new Number(c.replace(/e.+$/,'')).toFixed(b).valueOf()}return parseFloat(c.replace(/0+$/,'')+d)},_binaryOp:function(a,b,c){a=$.calculator._getInst(a);if(!a._newValue&&a._pendingOp){a._pendingOp(a);var d=$.calculator._get(a,'base');a.curValue=(d==10?a.curValue:Math.floor(a.curValue));a.dispValue=$.calculator._tidy(a.curValue,$.calculator._get(a,'precision')).toString(d).toUpperCase()}a.prevValue=a.curValue;a._newValue=true;a._pendingOp=b;$.calculator._sendButton(a,c);$.calculator._updateCalculator(a)},_add:function(a){a.curValue=a.prevValue+a.curValue},_subtract:function(a){a.curValue=a.prevValue-a.curValue},_multiply:function(a){a.curValue=a.prevValue*a.curValue},_divide:function(a){a.curValue=a.prevValue/a.curValue},_power:function(a){a.curValue=Math.pow(a.prevValue,a.curValue)},_unaryOp:function(a,b,c){a=$.calculator._getInst(a);a._newValue=true;b(a);var d=$.calculator._get(a,'base');a.curValue=(d==10?a.curValue:Math.floor(a.curValue));a.dispValue=$.calculator._tidy(a.curValue,$.calculator._get(a,'precision')).toString(d).toUpperCase();$.calculator._sendButton(a,c);$.calculator._updateCalculator(a)},_plusMinus:function(a){a.curValue=-1*a.curValue;a.dispValue=a.curValue.toString($.calculator._get(a,'base')).toUpperCase();a._newValue=false},_pi:function(a){a.curValue=Math.PI},_percent:function(a){if(a._pendingOp==$.calculator._add){a.curValue=a.prevValue*(1+a.curValue/100)}else if(a._pendingOp==$.calculator._subtract){a.curValue=a.prevValue*(1-a.curValue/100)}else if(a._pendingOp==$.calculator._multiply){a.curValue=a.prevValue*a.curValue/100}else if(a._pendingOp==$.calculator._divide){a.curValue=a.prevValue/a.curValue*100}a._savedOp=a._pendingOp;a._pendingOp=$.calculator._noOp},_equals:function(a){if(a._pendingOp==$.calculator._noOp){if(a._savedOp!=$.calculator._noOp){a.prevValue=a.curValue;a.curValue=a._savedValue;a._savedOp(a)}}else{a._savedOp=a._pendingOp;a._savedValue=a.curValue;a._pendingOp(a);a._pendingOp=$.calculator._noOp}},_memAdd:function(a){a.memory+=a.curValue},_memSubtract:function(a){a.memory-=a.curValue},_memStore:function(a){a.memory=a.curValue},_memRecall:function(a){a.curValue=a.memory},_memClear:function(a){a.memory=0},_sin:function(a){$.calculator._trig(a,Math.sin)},_cos:function(a){$.calculator._trig(a,Math.cos)},_tan:function(a){$.calculator._trig(a,Math.tan)},_trig:function(a,b){var c=$.calculator._get(a,'useDegrees');a.curValue=b(a.curValue*(c?Math.PI/180:1))},_asin:function(a){$.calculator._atrig(a,Math.asin)},_acos:function(a){$.calculator._atrig(a,Math.acos)},_atan:function(a){$.calculator._atrig(a,Math.atan)},_atrig:function(a,b){a.curValue=b(a.curValue);if($.calculator._get(a,'useDegrees')){a.curValue=a.curValue/Math.PI*180}},_inverse:function(a){a.curValue=1/a.curValue},_log:function(a){a.curValue=Math.log(a.curValue)/Math.log(10)},_ln:function(a){a.curValue=Math.log(a.curValue)},_exp:function(a){a.curValue=Math.exp(a.curValue)},_sqr:function(a){a.curValue*=a.curValue},_sqrt:function(a){a.curValue=Math.sqrt(a.curValue)},_random:function(a){a.curValue=Math.random()},_base2:function(a,b){$.calculator._changeBase(a,b,2)},_base8:function(a,b){$.calculator._changeBase(a,b,8)},_base10:function(a,b){$.calculator._changeBase(a,b,10)},_base16:function(a,b){$.calculator._changeBase(a,b,16)},_changeBase:function(a,b,c){a=$.calculator._getInst(a);a.settings.base=c;a.curValue=(c==10?a.curValue:Math.floor(a.curValue));a.dispValue=a.curValue.toString(c).toUpperCase();a._newValue=true;$.calculator._sendButton(a,b);$.calculator._updateCalculator(a)},_degrees:function(a,b){$.calculator._degreesRadians(a,b,true)},_radians:function(a,b){$.calculator._degreesRadians(a,b,false)},_degreesRadians:function(a,b,c){a=$.calculator._getInst(a);a.settings.useDegrees=c;$.calculator._sendButton(a,b);$.calculator._updateCalculator(a)},_undo:function(a,b){a=$.calculator._getInst(a);a.dispValue=a.dispValue.substr(0,a.dispValue.length-1)||'0';var c=$.calculator._get(a,'base');a.curValue=(c==10?parseFloat(a.dispValue):parseInt(a.dispValue,c));$.calculator._sendButton(a,b);$.calculator._updateCalculator(a)},_clearError:function(a,b){a=$.calculator._getInst(a);a.dispValue='0';a.curValue=0;a._newValue=true;$.calculator._sendButton(a,b);$.calculator._updateCalculator(a)},_clear:function(a,b){a=$.calculator._getInst(a);$.calculator._reset(a,0,false);$.calculator._sendButton(a,b);$.calculator._updateCalculator(a)},_close:function(a,b){a=$.calculator._getInst(a);$.calculator._finished(a,b,a._input.val())},_use:function(a,b){a=$.calculator._getInst(a);$.calculator._finished(a,b,a.dispValue)},_erase:function(a,b){a=$.calculator._getInst(a);$.calculator._finished(a,b,'')},_finished:function(a,b,c){a._input.val(c);$.calculator._sendButton(a,b);$.calculator._hideCalculator(a._input[0])}});function extendRemove(a,b){$.extend(a,b);for(var c in b){if(b[c]==null||b[c]==undefined){a[c]=b[c]}}return a};$.fn.calculator=function(a){var b=Array.prototype.slice.call(arguments,1);if(a=='isDisabled'){return $.calculator['_'+a+'Calculator'].apply($.calculator,[this[0]].concat(b))}return this.each(function(){typeof a=='string'?$.calculator['_'+a+'Calculator'].apply($.calculator,[this].concat(b)):$.calculator._attachCalculator(this,a)})};$.calculator=new Calculator();$(function(){$(document.body).append($.calculator.mainDiv).mousedown($.calculator._checkExternalClick)})})(jQuery);